declare class Reference {
    readonly id: number;
    constructor(id: number);
}
declare class Definition {
    readonly id: number;
    readonly value: SiloType;
    constructor(id: number, value: SiloType);
}
export declare type SiloType = number | boolean | string | null | {
    [key: string]: SiloType;
    [key: number]: SiloType;
} | SiloType[] | Reference | Definition;
export declare type ReturnSiloType = number | boolean | string | null | {
    [key: string]: ReturnSiloType;
    [key: number]: ReturnSiloType;
} | ReturnSiloType[];
export declare enum SiloLexType {
    String = 0,
    Number = 1,
    Boolean = 2,
    Separator = 3,
    Identifier = 4
}
export declare type SiloLex = {
    type: SiloLexType.String;
    value: string;
} | {
    type: SiloLexType.Identifier;
    value: string;
} | {
    type: SiloLexType.Number;
    value: number;
} | {
    type: SiloLexType.Separator;
    value: "[" | "]" | "{" | "}" | "," | "<" | ">" | ":" | "&" | "*";
} | {
    type: SiloLexType.Boolean;
    value: boolean;
};
export declare namespace SILO {
    function parse(t: string): ReturnSiloType;
    function serialize(t: any, currentPath?: string[], references?: Map<number, string[]>, index?: number): string;
}
export {};
